Subject: Re: [PATCH] net/ipv4/arp.c: Fix arp reply when sender ip 0

From: Jarek Poplawski <[email-masked]>
Date: Sat, 17 Nov 2007 23:14:04 +0100

Bill Fink wrote, On 11/16/2007 08:26 PM:
...

> Regarding the Target IP, RFC 826 says:
> 
> 	"The target protocol address is necessary in the request form
> 	of the packet so that a machine can determine whether or not
> 	to enter the sender information in a table or to send a reply.
> 	It is not necessarily needed in the reply form if one assumes
> 	a reply is only provoked by a request.  It is included for
> 	completeness, network monitoring, and to simplify the suggested
> 	processing algorithm described above (which does not look at
> 	the opcode until AFTER putting the sender information in a
> 	table).
> 
> So it's ambiguous about the target IP address in an ARP reply packet,
> but a value of 0.0.0.0 makes more logical sense to me than using
> 192.168.0.1 in this example case, since it should reflect the requestor
> IP address, which is unknown in this case.

IMHO, you are mostly right, but, according to this, if it's ambiguous
then only, if there is the target IP or no target IP, so here 0.0.0.0
or 0.0.0.0...

Regards,
Jarek P.